
/********************************************
zmalloc.h

libmawk changes (C) 2009-2010, Tibor 'Igor2' Palinkas;
based on mawk code coming with the below copyright:

copyright 1991, Michael D. Brennan

This is a source file for mawk, an implementation of
the AWK programming language.

Mawk is distributed without warranty under the terms of
the GNU General Public License, version 2, 1991.
********************************************/

#ifndef  ZMALLOC_H
#define  ZMALLOC_H

#include <libmawk/nstd.h>

PTR mawk_bmalloc(mawk_state_t *, unsigned);
void mawk_bfree(mawk_state_t *, PTR, unsigned);
PTR mawk_zrealloc(mawk_state_t *, PTR, unsigned, unsigned);
char *mawk_zstrclone(mawk_state_t *, const char *s);

#define zmalloc(MAWK, size)  mawk_bmalloc(MAWK, (((unsigned)size)+ZBLOCKSZ-1)>>ZSHIFT)
#define zfree(MAWK, p,size)  mawk_bfree(MAWK, p,(((unsigned)size)+ZBLOCKSZ-1)>>ZSHIFT)

#define ZMALLOC(type)  ((type*)zmalloc(MAWK, sizeof(type)))
#define ZFREE(p)	zfree(MAWK, p,sizeof(*(p)))


#endif /* ZMALLOC_H */
