/*
 *  ipscripts.c - scritpable network filtering
 */
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include "libmawk.h"

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Tibor Palinkas <libmawk _at_ repo.hu>");
MODULE_DESCRIPTION("libmawk: kernel space AWK");


static int __init lmawk_init(void)
{
	printk(KERN_INFO "lmawk_init\n");
	return 0;
}

static void __exit lmawk_exit(void)
{
	printk(KERN_INFO "lmawk_exit\n");
}

module_init(lmawk_init);
module_exit(lmawk_exit);


int errno;
void mawk_exit_(mawk_state_t *MAWK, int x)
{
	MAWK->do_exit = 1;
	mawk_close_out_pipes(MAWK);		/* no effect, if no out pipes */
	MAWK->final_exit_code = MAWK->rt_exit_code != 0 ? MAWK->rt_exit_code : x;
}

static char strerror_buff[16];
char *strerror(int errno)
{
	sprintf(strerror_buff, "E%d", errno);
	return strerror_buff;
}

void mawk_debug_callstack_pop(mawk_state_t * MAWK)
{

}

void mawk_debug_callstack_push(mawk_state_t * MAWK, FBLOCK * f)
{

}

void mawk_location_change(mawk_state_t * MAWK, int new_token_line)
{

}


/*
 *  This module uses /dev/testdevice.  The MODULE_SUPPORTED_DEVICE macro might
 *  be used in the future to help automatic configuration of modules, but is
 *  currently unused other than for documentation purposes.
 */
/*MODULE_SUPPORTED_DEVICE("testdevice");*/
